# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xarchive`](#dsc_xarchive): The DSC xArchive resource type. Automatically generated from version 9.2.0
* [`dsc_xdscwebservice`](#dsc_xdscwebservice): The DSC xDSCWebService resource type. Automatically generated from version 9.2.0
* [`dsc_xenvironment`](#dsc_xenvironment): The DSC xEnvironment resource type. Automatically generated from version 9.2.0
* [`dsc_xfileupload`](#dsc_xfileupload): The DSC  resource type. Automatically generated from version 9.2.0
* [`dsc_xgroup`](#dsc_xgroup): The DSC xGroup resource type. Automatically generated from version 9.2.0
* [`dsc_xgroupset`](#dsc_xgroupset): The DSC  resource type. Automatically generated from version 9.2.0
* [`dsc_xmsipackage`](#dsc_xmsipackage): The DSC xMsiPackage resource type. Automatically generated from version 9.2.0
* [`dsc_xpackage`](#dsc_xpackage): The DSC xPackage resource type. Automatically generated from version 9.2.0
* [`dsc_xprocessset`](#dsc_xprocessset): The DSC  resource type. Automatically generated from version 9.2.0
* [`dsc_xpsendpoint`](#dsc_xpsendpoint): The DSC xPSEndpoint resource type. Automatically generated from version 9.2.0
* [`dsc_xregistry`](#dsc_xregistry): The DSC xRegistry resource type. Automatically generated from version 9.2.0
* [`dsc_xremotefile`](#dsc_xremotefile): The DSC xRemoteFile resource type. Automatically generated from version 9.2.0
* [`dsc_xscript`](#dsc_xscript): The DSC xScript resource type. Automatically generated from version 9.2.0
* [`dsc_xservice`](#dsc_xservice): The DSC xService resource type. Automatically generated from version 9.2.0
* [`dsc_xserviceset`](#dsc_xserviceset): The DSC  resource type. Automatically generated from version 9.2.0
* [`dsc_xuser`](#dsc_xuser): The DSC xUser resource type. Automatically generated from version 9.2.0
* [`dsc_xwindowsfeature`](#dsc_xwindowsfeature): The DSC xWindowsFeature resource type. Automatically generated from version 9.2.0
* [`dsc_xwindowsfeatureset`](#dsc_xwindowsfeatureset): The DSC  resource type. Automatically generated from version 9.2.0
* [`dsc_xwindowsoptionalfeature`](#dsc_xwindowsoptionalfeature): The DSC xWindowsOptionalFeature resource type. Automatically generated from version 9.2.0
* [`dsc_xwindowsoptionalfeatureset`](#dsc_xwindowsoptionalfeatureset): The DSC  resource type. Automatically generated from version 9.2.0
* [`dsc_xwindowspackagecab`](#dsc_xwindowspackagecab): The DSC xWindowsPackageCab resource type. Automatically generated from version 9.2.0
* [`dsc_xwindowsprocess`](#dsc_xwindowsprocess): The DSC xWindowsProcess resource type. Automatically generated from version 9.2.0

## Resource types

### <a name="dsc_xarchive"></a>`dsc_xarchive`

The DSC xArchive resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xarchive` type.

##### `dsc_checksum`

Data type: `Optional[Enum['SHA-1', 'sha-1', 'SHA-256', 'sha-256', 'SHA-512', 'sha-512', 'CreatedDate', 'createddate', 'ModifiedDate', 'modifieddate']]`

The Checksum method to use to validate whether or not a file at the destination with the same name as a file in the archive actually matches that corresponding file in the archive. An invalid argument exception will be thrown if Checksum is specified while Validate is specified as false. ModifiedDate will check that the LastWriteTime property of the file at the destination matches the LastWriteTime property of the file in the archive. CreatedDate will check that the CreationTime property of the file at the destination matches the CreationTime property of the file in the archive. SHA-1, SHA-256, and SHA-512 will check that the hash of the file at the destination by the specified SHA method matches the hash of the file in the archive by the specified SHA method. The default value is ModifiedDate.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies whether or not the expanded content of the archive file at the specified path should exist at the specified destination. To update the specified destination to have the expanded content of the archive file at the specified path, specify this property as Present. To remove the expanded content of the archive file at the specified path from the specified destination, specify this property as Absent. The default value is Present.

#### Parameters

The following parameters are available in the `dsc_xarchive` type.

* [`dsc_credential`](#-dsc_xarchive--dsc_credential)
* [`dsc_destination`](#-dsc_xarchive--dsc_destination)
* [`dsc_force`](#-dsc_xarchive--dsc_force)
* [`dsc_path`](#-dsc_xarchive--dsc_path)
* [`dsc_psdscrunascredential`](#-dsc_xarchive--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xarchive--dsc_timeout)
* [`dsc_validate`](#-dsc_xarchive--dsc_validate)
* [`name`](#-dsc_xarchive--name)
* [`validation_mode`](#-dsc_xarchive--validation_mode)

##### <a name="-dsc_xarchive--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credential of a user account with permissions to access the specified archive path and destination if needed.

##### <a name="-dsc_xarchive--dsc_destination"></a>`dsc_destination`

namevar

Data type: `String`

The path where the specified archive file should be expanded to or removed from.

##### <a name="-dsc_xarchive--dsc_force"></a>`dsc_force`

Data type: `Optional[Boolean]`

Specifies whether or not any existing files or directories at the destination with the same name as a file or directory
in the archive should be overwritten to match the file or directory in the archive. When this property is false, an
error will be thrown if an item at the destination needs to be overwritten. The default value is false.

##### <a name="-dsc_xarchive--dsc_path"></a>`dsc_path`

namevar

Data type: `String`

The path to the archive file that should be expanded to or removed from the specified destination.

##### <a name="-dsc_xarchive--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xarchive--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xarchive--dsc_validate"></a>`dsc_validate`

Data type: `Optional[Boolean]`

Specifies whether or not to validate that a file at the destination with the same name as a file in the archive actually
matches that corresponding file in the archive by the specified checksum method. If the file does not match and Ensure
is specified as Present and Force is not specified, the resource will throw an error that the file at the destination
cannot be overwritten. If the file does not match and Ensure is specified as Present and Force is specified, the file at
the destination will be overwritten. If the file does not match and Ensure is specified as Absent, the file at the
destination will not be removed. The default value is false.

##### <a name="-dsc_xarchive--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xarchive--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xdscwebservice"></a>`dsc_xdscwebservice`

The DSC xDSCWebService resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xdscwebservice` type.

##### `dsc_acceptselfsignedcertificates`

Data type: `Optional[Boolean]`

Specifies is self-signed certs will be accepted for client authentication.

##### `dsc_applicationpoolname`

Data type: `Optional[String]`

The IIS Application Pool to use for the Pull Server. If not specified a pool with name 'PSWS' will be created.

##### `dsc_certificatesubject`

Data type: `Optional[String]`

The subject of the Certificate in CERT:\LocalMachine\MY\ for Pull Server.

##### `dsc_certificatetemplatename`

Data type: `Optional[String]`

The certificate Template Name of the Certificate in CERT:\LocalMachine\MY\ for Pull Server.

##### `dsc_certificatethumbprint`

Data type: `Optional[String]`

The thumbprint of the Certificate in CERT:\LocalMachine\MY\ for Pull Server.

##### `dsc_configurationpath`

Data type: `Optional[String]`

The location on the disk where the Configuration is stored.

##### `dsc_configurefirewall`

Data type: `Optional[Boolean]`

Enable incoming firewall exceptions for the configured DSC Pull Server port. Defaults to true.

##### `dsc_databasepath`

Data type: `Optional[String]`

The location on the disk where the database is stored.

##### `dsc_disablesecuritybestpractices`

Data type: `Optional[Array[Enum['SecureTLSProtocols', 'securetlsprotocols']]]`

A list of exceptions to the security best practices to apply.

##### `dsc_dscserverurl`

Data type: `Optional[String]`

The URL of the DSC Pull Server.

##### `dsc_enable32bitapponwin64`

Data type: `Optional[Boolean]`

Enable the DSC Pull Server to run in a 32-bit process on a 64-bit operating system.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies if the DSC Web Service should be installed.

##### `dsc_modulepath`

Data type: `Optional[String]`

The location on the disk where the Modules are stored.

##### `dsc_physicalpath`

Data type: `Optional[String]`

The physical path for the IIS Endpoint on the machine (usually under inetpub).

##### `dsc_port`

Data type: `Optional[Integer[0, 4294967295]]`

The port number of the DSC Pull Server IIS Endpoint.

##### `dsc_registrationkeypath`

Data type: `Optional[String]`

The location on the disk where the RegistrationKeys file is stored.

##### `dsc_sqlconnectionstring`

Data type: `Optional[String]`

The connection string to use to connect to the SQL server backend database. Required if SqlProvider is true.

##### `dsc_sqlprovider`

Data type: `Optional[Boolean]`

Enable DSC Pull Server to use SQL server as the backend database.

##### `dsc_state`

Data type: `Optional[Enum['Started', 'started', 'Stopped', 'stopped']]`

Specifies the state of the DSC Web Service.

##### `dsc_usesecuritybestpractices`

Data type: `Boolean`

This property will ensure that the Pull Server is created with the most secure practices.

#### Parameters

The following parameters are available in the `dsc_xdscwebservice` type.

* [`dsc_endpointname`](#-dsc_xdscwebservice--dsc_endpointname)
* [`dsc_psdscrunascredential`](#-dsc_xdscwebservice--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xdscwebservice--dsc_timeout)
* [`name`](#-dsc_xdscwebservice--name)
* [`validation_mode`](#-dsc_xdscwebservice--validation_mode)

##### <a name="-dsc_xdscwebservice--dsc_endpointname"></a>`dsc_endpointname`

namevar

Data type: `String`

Prefix of the WCF SVC file.

##### <a name="-dsc_xdscwebservice--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xdscwebservice--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xdscwebservice--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xdscwebservice--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xenvironment"></a>`dsc_xenvironment`

The DSC xEnvironment resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xenvironment` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies if the environment variable should exist.

##### `dsc_path`

Data type: `Optional[Boolean]`

Indicates whether or not the environment variable is a path variable. If the variable being configured is a path variable, the value provided will be appended to or removed from the existing value, otherwise the existing value will be replaced by the new value. When configured as a Path variable, multiple entries separated by semicolons are ensured to be either present or absent without affecting other Path entries.

##### `dsc_target`

Data type: `Optional[Array[Enum['Process', 'process', 'Machine', 'machine']]]`

Indicates the target where the environment variable should be set.

##### `dsc_value`

Data type: `Optional[String]`

The desired value for the environment variable. The default value is an empty string which either indicates that the variable should be removed entirely or that the value does not matter when testing its existence. Multiple entries can be entered and separated by semicolons.

#### Parameters

The following parameters are available in the `dsc_xenvironment` type.

* [`dsc_name`](#-dsc_xenvironment--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_xenvironment--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xenvironment--dsc_timeout)
* [`name`](#-dsc_xenvironment--name)
* [`validation_mode`](#-dsc_xenvironment--validation_mode)

##### <a name="-dsc_xenvironment--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

The name of the environment variable for which you want to ensure a specific state.

##### <a name="-dsc_xenvironment--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xenvironment--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xenvironment--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xenvironment--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xfileupload"></a>`dsc_xfileupload`

The DSC  resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xfileupload` type.

##### `dsc_certificatethumbprint`

Data type: `Optional[String]`

 

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

#### Parameters

The following parameters are available in the `dsc_xfileupload` type.

* [`dsc_destinationpath`](#-dsc_xfileupload--dsc_destinationpath)
* [`dsc_sourcepath`](#-dsc_xfileupload--dsc_sourcepath)
* [`dsc_timeout`](#-dsc_xfileupload--dsc_timeout)
* [`name`](#-dsc_xfileupload--name)
* [`validation_mode`](#-dsc_xfileupload--validation_mode)

##### <a name="-dsc_xfileupload--dsc_destinationpath"></a>`dsc_destinationpath`

namevar

Data type: `String`

 

##### <a name="-dsc_xfileupload--dsc_sourcepath"></a>`dsc_sourcepath`

namevar

Data type: `String`

 

##### <a name="-dsc_xfileupload--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xfileupload--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xfileupload--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xgroup"></a>`dsc_xgroup`

The DSC xGroup resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xgroup` type.

##### `dsc_description`

Data type: `Optional[String]`

The description the group should have.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Indicates if the group should exist or not.

##### `dsc_members`

Data type: `Optional[Array[String]]`

The members the group should have. This property will replace all the current group members with the specified members. Members should be specified as strings in the format of their domain qualified name, UPN ,distinguished name or username (for local machine accounts). Using either the MembersToExclude or MembersToInclude properties in the same configuration as this property will generate an error.

##### `dsc_memberstoexclude`

Data type: `Optional[Array[String]]`

The members the group should exclude. This property will only remove members from a group. Members should be specified as strings in the format of their domain qualified name, UPN ,distinguished name or username (for local machine accounts). Using the Members property in the same configuration as this property will generate an error.

##### `dsc_memberstoinclude`

Data type: `Optional[Array[String]]`

The members the group should include. This property will only add members to a group. Members should be specified as strings in the format of their domain qualified name, UPN ,distinguished name or username (for local machine accounts). Using the Members property in the same configuration as this property will generate an error.

#### Parameters

The following parameters are available in the `dsc_xgroup` type.

* [`dsc_credential`](#-dsc_xgroup--dsc_credential)
* [`dsc_groupname`](#-dsc_xgroup--dsc_groupname)
* [`dsc_psdscrunascredential`](#-dsc_xgroup--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xgroup--dsc_timeout)
* [`name`](#-dsc_xgroup--name)
* [`validation_mode`](#-dsc_xgroup--validation_mode)

##### <a name="-dsc_xgroup--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

A credential to resolve non-local group members.

##### <a name="-dsc_xgroup--dsc_groupname"></a>`dsc_groupname`

namevar

Data type: `String`

The name of the group to create, modify, or remove.

##### <a name="-dsc_xgroup--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xgroup--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xgroup--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xgroup--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xgroupset"></a>`dsc_xgroupset`

The DSC  resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xgroupset` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_ensure`

Data type: `Optional[String]`

 

##### `dsc_memberstoexclude`

Data type: `Optional[Array[String]]`

 

##### `dsc_memberstoinclude`

Data type: `Optional[Array[String]]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

#### Parameters

The following parameters are available in the `dsc_xgroupset` type.

* [`dsc_groupname`](#-dsc_xgroupset--dsc_groupname)
* [`dsc_timeout`](#-dsc_xgroupset--dsc_timeout)
* [`name`](#-dsc_xgroupset--name)
* [`validation_mode`](#-dsc_xgroupset--validation_mode)

##### <a name="-dsc_xgroupset--dsc_groupname"></a>`dsc_groupname`

namevar

Data type: `Array[String]`

 

##### <a name="-dsc_xgroupset--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xgroupset--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xgroupset--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xmsipackage"></a>`dsc_xmsipackage`

The DSC xMsiPackage resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xmsipackage` type.

##### `dsc_arguments`

Data type: `Optional[String]`

The arguments to be passed to the MSI package during installation or uninstallation.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies whether or not the MSI file should be installed or uninstalled.

##### `dsc_filehash`

Data type: `Optional[String]`

The expected hash value of the MSI file at the given path.

##### `dsc_hashalgorithm`

Data type: `Optional[Enum['SHA1', 'sha1', 'SHA256', 'sha256', 'SHA384', 'sha384', 'SHA512', 'sha512', 'MD5', 'md5', 'RIPEMD160', 'ripemd160']]`

The algorithm used to generate the given hash value.

##### `dsc_ignorereboot`

Data type: `Optional[Boolean]`

Ignore a pending reboot if requested by package installation.

##### `dsc_installedon`

Data type: `Optional[String]`

The date that the MSI package was installed on or serviced on, whichever is later.

##### `dsc_installsource`

Data type: `Optional[String]`

The path to the MSI package.

##### `dsc_logpath`

Data type: `Optional[String]`

The path to the log file to log the output from the MSI execution.

##### `dsc_name`

Data type: `Optional[String]`

The display name of the MSI package.

##### `dsc_packagedescription`

Data type: `Optional[String]`

The description of the MSI package.

##### `dsc_path`

Data type: `String`

The path to the MSI file that should be installed or uninstalled.

##### `dsc_publisher`

Data type: `Optional[String]`

The publisher of the MSI package.

##### `dsc_servercertificatevalidationcallback`

Data type: `Optional[String]`

PowerShell code that should be used to validate SSL certificates for paths using HTTPS.

##### `dsc_signersubject`

Data type: `Optional[String]`

The subject that should match the signer certificate of the digital signature of the MSI file.

##### `dsc_signerthumbprint`

Data type: `Optional[String]`

The certificate thumbprint that should match the signer certificate of the digital signature of the MSI file.

##### `dsc_size`

Data type: `Optional[Integer[0, 4294967295]]`

The size of the MSI package in MB.

##### `dsc_version`

Data type: `Optional[String]`

The version number of the MSI package.

#### Parameters

The following parameters are available in the `dsc_xmsipackage` type.

* [`dsc_credential`](#-dsc_xmsipackage--dsc_credential)
* [`dsc_productid`](#-dsc_xmsipackage--dsc_productid)
* [`dsc_psdscrunascredential`](#-dsc_xmsipackage--dsc_psdscrunascredential)
* [`dsc_runascredential`](#-dsc_xmsipackage--dsc_runascredential)
* [`dsc_timeout`](#-dsc_xmsipackage--dsc_timeout)
* [`name`](#-dsc_xmsipackage--name)
* [`validation_mode`](#-dsc_xmsipackage--validation_mode)

##### <a name="-dsc_xmsipackage--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credential of a user account to be used to mount a UNC path if needed.

##### <a name="-dsc_xmsipackage--dsc_productid"></a>`dsc_productid`

namevar

Data type: `String`

The identifying number used to find the package, usually a GUID.

##### <a name="-dsc_xmsipackage--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xmsipackage--dsc_runascredential"></a>`dsc_runascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credential of a user account under which to run the installation or uninstallation of the MSI package.

##### <a name="-dsc_xmsipackage--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xmsipackage--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xmsipackage--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xpackage"></a>`dsc_xpackage`

The DSC xPackage resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xpackage` type.

##### `dsc_arguments`

Data type: `Optional[String]`

The arguments to be passed to the package during addition or removal. When installing MSI packages, the '/quiet' and '/norestart' arguments are automatically applied.

##### `dsc_createcheckregvalue`

Data type: `Optional[Boolean]`

Specifies if a registry value should be created when the packages is installed.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Indicates whether to Ensure that the package is 'Present' or 'Absent'. Defaults to 'Present'.

##### `dsc_filehash`

Data type: `Optional[String]`

The expected hash value of the file found in the Path location.

##### `dsc_hashalgorithm`

Data type: `Optional[Enum['SHA1', 'sha1', 'SHA256', 'sha256', 'SHA384', 'sha384', 'SHA512', 'sha512', 'MD5', 'md5', 'RIPEMD160', 'ripemd160']]`

The algorithm used to generate the FileHash value. Defaults to 'SHA256'.

##### `dsc_ignorereboot`

Data type: `Optional[Boolean]`

Ignore a pending reboot if requested by package installation. The default value is $false and DSC will try to reboot the system.

##### `dsc_installed`

Data type: `Optional[Boolean]`

Whether the identified package is installed.

##### `dsc_installedcheckreghive`

Data type: `Optional[Enum['LocalMachine', 'localmachine', 'CurrentUser', 'currentuser']]`

The hive in which to create the registry key. Defaults to 'LocalMachine'.

##### `dsc_installedcheckregkey`

Data type: `Optional[String]`

The registry key to validate the package is installed.

##### `dsc_installedcheckregvaluedata`

Data type: `Optional[String]`

The registry value to validate the package is installed.

##### `dsc_installedcheckregvaluename`

Data type: `Optional[String]`

The registry value name to validate the package is installed.

##### `dsc_installedon`

Data type: `Optional[String]`

The date that the identified package was last serviced or its install date, whichever is later.

##### `dsc_logpath`

Data type: `Optional[String]`

The path to log the output of the MSI or EXE.

##### `dsc_packagedescription`

Data type: `Optional[String]`

The description of the identified package.

##### `dsc_path`

Data type: `String`

The path, URL or UNC path to the package.

##### `dsc_publisher`

Data type: `Optional[String]`

The publisher for the identified package.

##### `dsc_returncode`

Data type: `Optional[Array[Integer[0, 4294967295]]]`

The list of possible valid return codes for this install or removal.

##### `dsc_servercertificatevalidationcallback`

Data type: `Optional[String]`

PowerShell code used to validate SSL certificates of HTTPS url assigned to Path.

##### `dsc_signersubject`

Data type: `Optional[String]`

The subject that must match the signer certificate of the digital signature. Wildcards are allowed.

##### `dsc_signerthumbprint`

Data type: `Optional[String]`

The certificate thumbprint which must match the signer certificate of the digital signature.

##### `dsc_size`

Data type: `Optional[Integer[0, 4294967295]]`

The size of the identified package.

##### `dsc_version`

Data type: `Optional[String]`

The version number of the identified package.

#### Parameters

The following parameters are available in the `dsc_xpackage` type.

* [`dsc_credential`](#-dsc_xpackage--dsc_credential)
* [`dsc_name`](#-dsc_xpackage--dsc_name)
* [`dsc_productid`](#-dsc_xpackage--dsc_productid)
* [`dsc_psdscrunascredential`](#-dsc_xpackage--dsc_psdscrunascredential)
* [`dsc_runascredential`](#-dsc_xpackage--dsc_runascredential)
* [`dsc_timeout`](#-dsc_xpackage--dsc_timeout)
* [`name`](#-dsc_xpackage--name)
* [`validation_mode`](#-dsc_xpackage--validation_mode)

##### <a name="-dsc_xpackage--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credentials to be used for mounting the UNC path (if applicable).

##### <a name="-dsc_xpackage--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

The name of the package to be added or removed.

##### <a name="-dsc_xpackage--dsc_productid"></a>`dsc_productid`

namevar

Data type: `String`

The identifying number used to uniquely identify this package.

##### <a name="-dsc_xpackage--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xpackage--dsc_runascredential"></a>`dsc_runascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credentials under which to run the installation.

##### <a name="-dsc_xpackage--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xpackage--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xpackage--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xprocessset"></a>`dsc_xprocessset`

The DSC  resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xprocessset` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_ensure`

Data type: `Optional[String]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_standarderrorpath`

Data type: `Optional[String]`

 

##### `dsc_standardinputpath`

Data type: `Optional[String]`

 

##### `dsc_standardoutputpath`

Data type: `Optional[String]`

 

##### `dsc_workingdirectory`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_xprocessset` type.

* [`dsc_path`](#-dsc_xprocessset--dsc_path)
* [`dsc_timeout`](#-dsc_xprocessset--dsc_timeout)
* [`name`](#-dsc_xprocessset--name)
* [`validation_mode`](#-dsc_xprocessset--validation_mode)

##### <a name="-dsc_xprocessset--dsc_path"></a>`dsc_path`

namevar

Data type: `Array[String]`

 

##### <a name="-dsc_xprocessset--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xprocessset--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xprocessset--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xpsendpoint"></a>`dsc_xpsendpoint`

The DSC xPSEndpoint resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xpsendpoint` type.

##### `dsc_accessmode`

Data type: `Optional[Enum['Local', 'local', 'Remote', 'remote', 'Disabled', 'disabled']]`

Enables and disables the session configuration and determines whether it can be used for remote or local sessions on the computer. The default value is 'Remote'.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Indicates if the session configuration should exist. The default value is 'Present'.

##### `dsc_securitydescriptorsddl`

Data type: `Optional[String]`

Specifies the Security Descriptor Definition Language (SDDL) string for the configuration. This string determines the permissions that are required to use the new session configuration. To use a session configuration in a session, users must have at least Execute(Invoke) permission for the configuration.

##### `dsc_startupscript`

Data type: `Optional[String]`

Specifies the startup script for the configuration. Enter the fully qualified path of a Windows PowerShell script.

#### Parameters

The following parameters are available in the `dsc_xpsendpoint` type.

* [`dsc_name`](#-dsc_xpsendpoint--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_xpsendpoint--dsc_psdscrunascredential)
* [`dsc_runascredential`](#-dsc_xpsendpoint--dsc_runascredential)
* [`dsc_timeout`](#-dsc_xpsendpoint--dsc_timeout)
* [`name`](#-dsc_xpsendpoint--name)
* [`validation_mode`](#-dsc_xpsendpoint--validation_mode)

##### <a name="-dsc_xpsendpoint--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the session configuration.

##### <a name="-dsc_xpsendpoint--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xpsendpoint--dsc_runascredential"></a>`dsc_runascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the credential for commands of this session configuration. By default, commands run with the permissions of
the current user.

##### <a name="-dsc_xpsendpoint--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xpsendpoint--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xpsendpoint--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xregistry"></a>`dsc_xregistry`

The DSC xRegistry resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xregistry` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies whether or not the registry key or value should exist. To add or modify a registry key or value, set this property to Present. To remove a registry key or value, set the property to Absent.

##### `dsc_hex`

Data type: `Optional[Boolean]`

Specifies whether or not the specified DWord or QWord registry key data is provided in a hexadecimal format. Not valid for types other than DWord and QWord. The default value is $false.

##### `dsc_valuedata`

Data type: `Optional[Array[String]]`

The data the specified registry key value should have as a string or an array of strings (MultiString only).

##### `dsc_valuetype`

Data type: `Optional[Enum['String', 'string', 'Binary', 'binary', 'DWord', 'dword', 'QWord', 'qword', 'MultiString', 'multistring', 'ExpandString', 'expandstring']]`

The type the specified registry key value should have.

#### Parameters

The following parameters are available in the `dsc_xregistry` type.

* [`dsc_force`](#-dsc_xregistry--dsc_force)
* [`dsc_key`](#-dsc_xregistry--dsc_key)
* [`dsc_psdscrunascredential`](#-dsc_xregistry--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xregistry--dsc_timeout)
* [`dsc_valuename`](#-dsc_xregistry--dsc_valuename)
* [`name`](#-dsc_xregistry--name)
* [`validation_mode`](#-dsc_xregistry--validation_mode)

##### <a name="-dsc_xregistry--dsc_force"></a>`dsc_force`

Data type: `Optional[Boolean]`

Specifies whether or not to overwrite the specified registry key value if it already has a value or whether or not to
delete a registry key that has subkeys. The default value is $false.

##### <a name="-dsc_xregistry--dsc_key"></a>`dsc_key`

namevar

Data type: `String`

The path of the registry key to add, modify, or remove. This path must include the registry hive/drive.

##### <a name="-dsc_xregistry--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xregistry--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xregistry--dsc_valuename"></a>`dsc_valuename`

namevar

Data type: `String`

The name of the registry value. To add or remove a registry key, specify this property as an empty string without
specifying ValueType or ValueData. To modify or remove the default value of a registry key, specify this property as an
empty string while also specifying ValueType or ValueData.

##### <a name="-dsc_xregistry--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xregistry--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xremotefile"></a>`dsc_xremotefile`

The DSC xRemoteFile resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xremotefile` type.

##### `dsc_checksum`

Data type: `Optional[String]`

Specifies the expected checksum value of downloaded file.

##### `dsc_checksumtype`

Data type: `Optional[Enum['None', 'none', 'SHA1', 'sha1', 'SHA256', 'sha256', 'SHA384', 'sha384', 'SHA512', 'sha512', 'MACTripleDES', 'mactripledes', 'MD5', 'md5', 'RIPEMD160', 'ripemd160']]`

Specifies the algorithm used to calculate the checksum of the file.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Returns whether the destination path exists on the machine.

##### `dsc_headers`

Data type: `Optional[Array[Struct[{
              key => Optional[String],
              value => Optional[String],
            }]]]`

Headers of the web request.

##### `dsc_matchsource`

Data type: `Optional[Boolean]`

Determines whether the remote file should be re-downloaded if file in the DestinationPath was modified locally. The default value is true.

##### `dsc_proxy`

Data type: `Optional[String]`

Uses a proxy server for the request, rather than connecting directly to the Internet resource. Should be the URI of a network proxy server (e.g 'http://10.20.30.1').

##### `dsc_timeoutsec`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies how long the request can be pending before it times out.

##### `dsc_uri`

Data type: `String`

URI of the file which should be downloaded. It must be a HTTP, HTTPS or FILE resource.

##### `dsc_useragent`

Data type: `Optional[String]`

User agent for the web request.

#### Parameters

The following parameters are available in the `dsc_xremotefile` type.

* [`dsc_credential`](#-dsc_xremotefile--dsc_credential)
* [`dsc_destinationpath`](#-dsc_xremotefile--dsc_destinationpath)
* [`dsc_proxycredential`](#-dsc_xremotefile--dsc_proxycredential)
* [`dsc_psdscrunascredential`](#-dsc_xremotefile--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xremotefile--dsc_timeout)
* [`name`](#-dsc_xremotefile--name)
* [`validation_mode`](#-dsc_xremotefile--validation_mode)

##### <a name="-dsc_xremotefile--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies credential of a user which has permissions to send the request.

##### <a name="-dsc_xremotefile--dsc_destinationpath"></a>`dsc_destinationpath`

namevar

Data type: `String`

Path under which downloaded or copied file should be accessible after operation.

##### <a name="-dsc_xremotefile--dsc_proxycredential"></a>`dsc_proxycredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies a user account that has permission to use the proxy server that is specified by the Proxy parameter.

##### <a name="-dsc_xremotefile--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xremotefile--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xremotefile--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xremotefile--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xscript"></a>`dsc_xscript`

The DSC xScript resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xscript` type.

##### `dsc_result`

Data type: `Optional[String]`

The result from the GetScript script block.

#### Parameters

The following parameters are available in the `dsc_xscript` type.

* [`dsc_credential`](#-dsc_xscript--dsc_credential)
* [`dsc_getscript`](#-dsc_xscript--dsc_getscript)
* [`dsc_psdscrunascredential`](#-dsc_xscript--dsc_psdscrunascredential)
* [`dsc_setscript`](#-dsc_xscript--dsc_setscript)
* [`dsc_testscript`](#-dsc_xscript--dsc_testscript)
* [`dsc_timeout`](#-dsc_xscript--dsc_timeout)
* [`name`](#-dsc_xscript--name)
* [`validation_mode`](#-dsc_xscript--validation_mode)

##### <a name="-dsc_xscript--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credential of the user account to run the script under if needed.

##### <a name="-dsc_xscript--dsc_getscript"></a>`dsc_getscript`

namevar

Data type: `String`

A string that can be used to create a PowerShell script block that retrieves the current state of the resource. This
script block runs when the Get-DscConfiguration cmdlet is called. This script block should return a hash table
containing one key named Result with a string value.

##### <a name="-dsc_xscript--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xscript--dsc_setscript"></a>`dsc_setscript`

namevar

Data type: `String`

A string that can be used to create a PowerShell script block that sets the resource to the desired state. This script
block runs conditionally when the Start-DscConfiguration cmdlet is called. The TestScript script block will run first.
If the TestScript block returns False, this script block will run. If the TestScript block returns True, this script
block will not run. This script block should not return.

##### <a name="-dsc_xscript--dsc_testscript"></a>`dsc_testscript`

namevar

Data type: `String`

A string that can be used to create a PowerShell script block that validates whether or not the resource is in the
desired state. This script block runs when the Start-DscConfiguration cmdlet is called or when the Test-DscConfiguration
cmdlet is called. This script block should return a boolean with True meaning that the resource is in the desired state
and False meaning that the resource is not in the desired state.

##### <a name="-dsc_xscript--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xscript--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xscript--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xservice"></a>`dsc_xservice`

The DSC xService resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xservice` type.

##### `dsc_builtinaccount`

Data type: `Optional[Enum['LocalSystem', 'localsystem', 'LocalService', 'localservice', 'NetworkService', 'networkservice']]`

The built-in account the service should start under. Cannot be specified at the same time as Credential or GroupManagedServiceAccount. The user account specified by this property must have access to the service executable path defined by Path in order to start the service.

##### `dsc_dependencies`

Data type: `Optional[Array[String]]`

An array of strings indicating the names of the dependencies of the service.

##### `dsc_description`

Data type: `Optional[String]`

The description of the service.

##### `dsc_desktopinteract`

Data type: `Optional[Boolean]`

Indicates whether or not the service should be able to communicate with a window on the desktop. Must be false for services not running as LocalSystem. The default value is False.

##### `dsc_displayname`

Data type: `Optional[String]`

The display name of the service.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Ensures that the service is present or absent. Defaults to Present.

##### `dsc_groupmanagedserviceaccount`

Data type: `Optional[String]`

The Group Managed Service Account the service should start under. Cannot be specified at the same time as Credential or BuiltinAccount. The user account specified by this property must have access to the service executable path defined by Path in order to start the service. When specified in a DOMAIN\User$ form, remember to also input the trailing dollar sign.

##### `dsc_path`

Data type: `Optional[String]`

The path to the service executable file. Required when creating a service. The user account specified by BuiltInAccount or Credential must have access to this path in order to start the service.

##### `dsc_startuptimeout`

Data type: `Optional[Integer[0, 4294967295]]`

The time to wait for the service to start in milliseconds. Defaults to 30000 (30 seconds).

##### `dsc_startuptype`

Data type: `Optional[Enum['Automatic', 'automatic', 'Manual', 'manual', 'Disabled', 'disabled']]`

Indicates the startup type for the service. If StartupType is 'Disabled' and Service is not installed the resource will complete as being DSC compliant.

##### `dsc_state`

Data type: `Optional[Enum['Running', 'running', 'Stopped', 'stopped', 'Ignore', 'ignore']]`

Indicates the state you want to ensure for the service. Defaults to 'Running'.

##### `dsc_terminatetimeout`

Data type: `Optional[Integer[0, 4294967295]]`

The time to wait for the service to stop in milliseconds. Defaults to 30000 (30 seconds).

#### Parameters

The following parameters are available in the `dsc_xservice` type.

* [`dsc_credential`](#-dsc_xservice--dsc_credential)
* [`dsc_name`](#-dsc_xservice--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_xservice--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xservice--dsc_timeout)
* [`name`](#-dsc_xservice--name)
* [`validation_mode`](#-dsc_xservice--validation_mode)

##### <a name="-dsc_xservice--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credential of the user account the service should start under. Cannot be specified at the same time as
BuiltInAccount or GroupManagedServiceAccount. The user specified by this credential will automatically be granted the
Log on as a Service right. The user account specified by this property must have access to the service executable path
defined by Path in order to start the service.

##### <a name="-dsc_xservice--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Indicates the service name. Note that sometimes this is different from the display name. You can get a list of the
services and their current state with the Get-Service cmdlet.

##### <a name="-dsc_xservice--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xservice--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xservice--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xservice--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xserviceset"></a>`dsc_xserviceset`

The DSC  resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xserviceset` type.

##### `dsc_builtinaccount`

Data type: `Optional[String]`

 

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_ensure`

Data type: `Optional[String]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_startuptype`

Data type: `Optional[String]`

 

##### `dsc_state`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_xserviceset` type.

* [`dsc_name`](#-dsc_xserviceset--dsc_name)
* [`dsc_timeout`](#-dsc_xserviceset--dsc_timeout)
* [`name`](#-dsc_xserviceset--name)
* [`validation_mode`](#-dsc_xserviceset--validation_mode)

##### <a name="-dsc_xserviceset--dsc_name"></a>`dsc_name`

namevar

Data type: `Array[String]`

 

##### <a name="-dsc_xserviceset--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xserviceset--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xserviceset--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xuser"></a>`dsc_xuser`

The DSC xUser resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xuser` type.

##### `dsc_description`

Data type: `Optional[String]`

Indicates the description you want to use for the user account.

##### `dsc_disabled`

Data type: `Optional[Boolean]`

Indicates if the account is enabled. Set this property to $true to ensure that this account is disabled, and set it to $false to ensure that it is enabled. Defaults to $false.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specified if the user account is present or absent.

##### `dsc_fullname`

Data type: `Optional[String]`

The full name of the user account.

##### `dsc_passwordchangenotallowed`

Data type: `Optional[Boolean]`

Indicates if the user can change the password. Set this property to $true to ensure that the user cannot change the password, and set it to $false to allow the user to change the password.

##### `dsc_passwordchangerequired`

Data type: `Optional[Boolean]`

Indicates if the user must change the password at the next sign in. Set this property to $true if the user must change the password.

##### `dsc_passwordneverexpires`

Data type: `Optional[Boolean]`

Indicates if the password will expire. To ensure that the password for this account will never expire, set this property to $true, and set it to $false if the password will expire.

#### Parameters

The following parameters are available in the `dsc_xuser` type.

* [`dsc_password`](#-dsc_xuser--dsc_password)
* [`dsc_psdscrunascredential`](#-dsc_xuser--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xuser--dsc_timeout)
* [`dsc_username`](#-dsc_xuser--dsc_username)
* [`name`](#-dsc_xuser--name)
* [`validation_mode`](#-dsc_xuser--validation_mode)

##### <a name="-dsc_xuser--dsc_password"></a>`dsc_password`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Indicates the password you want to use for this account.

##### <a name="-dsc_xuser--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xuser--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xuser--dsc_username"></a>`dsc_username`

namevar

Data type: `String`

Indicates the account name for which you want to ensure a specific state.

##### <a name="-dsc_xuser--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xuser--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwindowsfeature"></a>`dsc_xwindowsfeature`

The DSC xWindowsFeature resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xwindowsfeature` type.

##### `dsc_displayname`

Data type: `Optional[String]`

The display name of the retrieved role or feature.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies whether the feature should be installed (Present) or uninstalled (Absent). Defaults to 'Present'.

##### `dsc_includeallsubfeature`

Data type: `Optional[Boolean]`

Set this property to $true to ensure the state of all required subfeatures with the state of the feature you specify with the Name property. The default value is $false.

##### `dsc_logpath`

Data type: `Optional[String]`

Indicates the path to a log file to log the operation. If not specified, the default log path will be used (%WINDIR%\logs\ServerManager.log).

#### Parameters

The following parameters are available in the `dsc_xwindowsfeature` type.

* [`dsc_credential`](#-dsc_xwindowsfeature--dsc_credential)
* [`dsc_name`](#-dsc_xwindowsfeature--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_xwindowsfeature--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xwindowsfeature--dsc_timeout)
* [`name`](#-dsc_xwindowsfeature--name)
* [`validation_mode`](#-dsc_xwindowsfeature--validation_mode)

##### <a name="-dsc_xwindowsfeature--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Indicates the credential to use to add or remove the role or feature if needed.

##### <a name="-dsc_xwindowsfeature--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Indicates the name of the role or feature that you want to ensure is added or removed. This is the same as the Name
property from the Get-WindowsFeature cmdlet, and not the display name of the role or feature.

##### <a name="-dsc_xwindowsfeature--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xwindowsfeature--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xwindowsfeature--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xwindowsfeature--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwindowsfeatureset"></a>`dsc_xwindowsfeatureset`

The DSC  resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xwindowsfeatureset` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_ensure`

Data type: `Optional[String]`

 

##### `dsc_includeallsubfeature`

Data type: `Optional[Boolean]`

 

##### `dsc_logpath`

Data type: `Optional[String]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_source`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_xwindowsfeatureset` type.

* [`dsc_name`](#-dsc_xwindowsfeatureset--dsc_name)
* [`dsc_timeout`](#-dsc_xwindowsfeatureset--dsc_timeout)
* [`name`](#-dsc_xwindowsfeatureset--name)
* [`validation_mode`](#-dsc_xwindowsfeatureset--validation_mode)

##### <a name="-dsc_xwindowsfeatureset--dsc_name"></a>`dsc_name`

namevar

Data type: `Array[String]`

 

##### <a name="-dsc_xwindowsfeatureset--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xwindowsfeatureset--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xwindowsfeatureset--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwindowsoptionalfeature"></a>`dsc_xwindowsoptionalfeature`

The DSC xWindowsOptionalFeature resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xwindowsoptionalfeature` type.

##### `dsc_customproperties`

Data type: `Optional[Array[String]]`

The custom properties retrieved from the Windows optional feature as an array of strings.

##### `dsc_description`

Data type: `Optional[String]`

The description retrieved from the Windows optional feature.

##### `dsc_displayname`

Data type: `Optional[String]`

The display name retrieved from the Windows optional feature.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies whether the feature should be enabled or disabled. To enable the feature, set this property to Present. To disable the feature, set the property to Absent. The default value is Present.

##### `dsc_loglevel`

Data type: `Optional[Enum['ErrorsOnly', 'errorsonly', 'ErrorsAndWarning', 'errorsandwarning', 'ErrorsAndWarningAndInformation', 'errorsandwarningandinformation']]`

The maximum output level to show in the log. Accepted values are: ErrorsOnly (only errors are logged), ErrorsAndWarning (errors and warnings are logged), and ErrorsAndWarningAndInformation (errors, warnings, and debug information are logged).

##### `dsc_logpath`

Data type: `Optional[String]`

The path to the log file to log this operation. There is no default value, but if not set, the log will appear at %WINDIR%\Logs\Dism\dism.log.

##### `dsc_nowindowsupdatecheck`

Data type: `Optional[Boolean]`

Specifies whether or not DISM contacts Windows Update (WU) when searching for the source files to enable the feature. If $true, DISM will not contact WU.

##### `dsc_removefilesondisable`

Data type: `Optional[Boolean]`

Specifies that all files associated with the feature should be removed if the feature is being disabled.

#### Parameters

The following parameters are available in the `dsc_xwindowsoptionalfeature` type.

* [`dsc_name`](#-dsc_xwindowsoptionalfeature--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_xwindowsoptionalfeature--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xwindowsoptionalfeature--dsc_timeout)
* [`name`](#-dsc_xwindowsoptionalfeature--name)
* [`validation_mode`](#-dsc_xwindowsoptionalfeature--validation_mode)

##### <a name="-dsc_xwindowsoptionalfeature--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

The name of the Windows optional feature to enable or disable.

##### <a name="-dsc_xwindowsoptionalfeature--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xwindowsoptionalfeature--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xwindowsoptionalfeature--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xwindowsoptionalfeature--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwindowsoptionalfeatureset"></a>`dsc_xwindowsoptionalfeatureset`

The DSC  resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xwindowsoptionalfeatureset` type.

##### `dsc_loglevel`

Data type: `Optional[String]`

 

##### `dsc_logpath`

Data type: `Optional[String]`

 

##### `dsc_nowindowsupdatecheck`

Data type: `Optional[Boolean]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_removefilesondisable`

Data type: `Optional[Boolean]`

 

#### Parameters

The following parameters are available in the `dsc_xwindowsoptionalfeatureset` type.

* [`dsc_ensure`](#-dsc_xwindowsoptionalfeatureset--dsc_ensure)
* [`dsc_name`](#-dsc_xwindowsoptionalfeatureset--dsc_name)
* [`dsc_timeout`](#-dsc_xwindowsoptionalfeatureset--dsc_timeout)
* [`name`](#-dsc_xwindowsoptionalfeatureset--name)
* [`validation_mode`](#-dsc_xwindowsoptionalfeatureset--validation_mode)

##### <a name="-dsc_xwindowsoptionalfeatureset--dsc_ensure"></a>`dsc_ensure`

namevar

Data type: `String`

 

##### <a name="-dsc_xwindowsoptionalfeatureset--dsc_name"></a>`dsc_name`

namevar

Data type: `Array[String]`

 

##### <a name="-dsc_xwindowsoptionalfeatureset--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xwindowsoptionalfeatureset--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xwindowsoptionalfeatureset--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwindowspackagecab"></a>`dsc_xwindowspackagecab`

The DSC xWindowsPackageCab resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xwindowspackagecab` type.

##### `dsc_ensure`

Data type: `Enum['Present', 'present', 'Absent', 'absent']`

Specifies whether the package should be installed or uninstalled. To install the package, set this property to Present. To uninstall the package, set the property to Absent.

##### `dsc_logpath`

Data type: `Optional[String]`

The path to a file to log the operation to.

##### `dsc_sourcepath`

Data type: `String`

The path to the cab file to install or uninstall the package from.

#### Parameters

The following parameters are available in the `dsc_xwindowspackagecab` type.

* [`dsc_name`](#-dsc_xwindowspackagecab--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_xwindowspackagecab--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xwindowspackagecab--dsc_timeout)
* [`name`](#-dsc_xwindowspackagecab--name)
* [`validation_mode`](#-dsc_xwindowspackagecab--validation_mode)

##### <a name="-dsc_xwindowspackagecab--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

The name of the package to install or uninstall.

##### <a name="-dsc_xwindowspackagecab--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xwindowspackagecab--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xwindowspackagecab--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xwindowspackagecab--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xwindowsprocess"></a>`dsc_xwindowsprocess`

The DSC xWindowsProcess resource type.
Automatically generated from version 9.2.0

#### Properties

The following properties are available in the `dsc_xwindowsprocess` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Indicates whether the process is present (running) or absent (not running).

##### `dsc_handlecount`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

The number of handles opened by the process.

##### `dsc_nonpagedmemorysize`

Data type: `Optional[Integer[0, 18446744073709551615]]`

The amount of nonpaged memory, in bytes, allocated for the process.

##### `dsc_pagedmemorysize`

Data type: `Optional[Integer[0, 18446744073709551615]]`

The amount of paged memory, in bytes, allocated for the process.

##### `dsc_processcount`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

The number of instances of the given process that are currently running.

##### `dsc_processid`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

The unique identifier of the process.

##### `dsc_standarderrorpath`

Data type: `Optional[String]`

The path to write the standard error stream to.

##### `dsc_standardinputpath`

Data type: `Optional[String]`

The path to receive standard input from.

##### `dsc_standardoutputpath`

Data type: `Optional[String]`

The path to write the standard output stream to.

##### `dsc_virtualmemorysize`

Data type: `Optional[Integer[0, 18446744073709551615]]`

The amount of virtual memory, in bytes, allocated for the process.

##### `dsc_workingdirectory`

Data type: `Optional[String]`

The directory to run the processes under.

#### Parameters

The following parameters are available in the `dsc_xwindowsprocess` type.

* [`dsc_arguments`](#-dsc_xwindowsprocess--dsc_arguments)
* [`dsc_credential`](#-dsc_xwindowsprocess--dsc_credential)
* [`dsc_path`](#-dsc_xwindowsprocess--dsc_path)
* [`dsc_psdscrunascredential`](#-dsc_xwindowsprocess--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_xwindowsprocess--dsc_timeout)
* [`name`](#-dsc_xwindowsprocess--name)
* [`validation_mode`](#-dsc_xwindowsprocess--validation_mode)

##### <a name="-dsc_xwindowsprocess--dsc_arguments"></a>`dsc_arguments`

namevar

Data type: `String`

A string of arguments to pass to the process executable. Pass in an empty string if no arguments are needed.

##### <a name="-dsc_xwindowsprocess--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credential to run the process under.

##### <a name="-dsc_xwindowsprocess--dsc_path"></a>`dsc_path`

namevar

Data type: `String`

The full path or file name to the process executable to start or stop.

##### <a name="-dsc_xwindowsprocess--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_xwindowsprocess--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_xwindowsprocess--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_xwindowsprocess--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

