# culture="en-US"
ConvertFrom-StringData -StringData @'
    InvalidCertificateThumbprint                         = CertificateThumbprint must contain a certificate thumbprint, or 'AllowUnencryptedTraffic' to opt-out from being secure.
    InvalidUseSecurityBestPractice                       = Cannot use best practice security settings with unencrypted traffic. Please set UseSecurityBestPractices to $false or use a certificate to encrypt pull server traffic.
    FindCertificateBySubjectMultiple                     = More than one certificate found with subject containing '{0}' and using template '{1}'.
    FindCertificateBySubjectNotFound                     = Certificate not found with subject containing '{0}' and using template '{1}'.
    IISInstallationPathNotFound                          = IIS installation path not found
    IISWebAdministrationAssemblyNotFound                 = IIS version of Microsoft.Web.Administration.dll not found
    ConfigFirewallDeprecated                             = The support for configuring firewall rules is deprecated. Please set ConfigureFirewall to false and use the Firewall resource from NetworkingDSC module to configure required firewall rules.
    ThrowApplicationPoolNotFound                         = IIS Application pool '{0}' not found.
    PullServerFound                                      = Pull Server web site with endpoint '{0}' found.
    PullServerNotFound                                   = Pull Server web site with endpoint '{0}' not found.
    PullServerAllowUnencryptedTraffic                    = Pull Server web site configuration allows unencrypted traffic.
    PullServerCertificateFound                           = Pull Server web site certificate '{0}' found.
    ProcessingPullServerBindings                         = Processing bindings for Pull Server web site '{0}'.
    RemovingPullServerWebSite                            = Removing Pull Server web site '{0}'.
    CreatingPullServerWebSite                            = Creating Pull Server web site '{0}'.
    AddingFirewallException                              = Adding firewall exception for port '{0}'.
    RemovingFirewallException                            = Removing firewall exception for port '{0}'.
    SetDatabaseConfigSqlProvider                         = Set Pull Server database connection values in 'Web.Config' to SQL Provider.
    SetDatabaseConfigEsentProvider                       = Set Pull Server database connection values in 'Web.Config' to ESENT Provider on BLUE OS.
    SetDatabaseConfigJetProvider                         = Set Pull Server database connection values in 'Web.Config' to Jet Provider on OS downlevel of BLUE.
    SetBindingRedirectConfig                             = Set Pull Server binding redirect in 'Web.Config' to '{0}'.
    SetPullServerWebConfigSettings                       = Set Pull Server location of repository, configuration and modules settings in 'Web.Config'.
    EnableAcceptSelfSignedCertificates                   = Enabling accept self signed certificates from incoming hosts on '{0}'.
    DisableAcceptSelfSignedCertificates                  = Disabling accept self signed certificates from incoming hosts on '{0}'.
    TestingPullServerWebSiteExistence                    = Testing the Pull Server web site existence.
    PullServerWebSiteDoesNotExistButShould               = Pull Server web site '{0}' does not exist but should be present.
    PullServerWebSiteExistsButShouldNot                  = Pull Server web site '{0}' exists but should be present.
    PullServerWebSiteDoesNotExistAndShouldNot            = Pull Server web site '{0}' exists and should not be present.
    TestingPullServerWebSitePort                         = Testing the Pull Server web site port.
    PullServerWebSitePortMismatch                        = Pull Server web site '{0}' port '{1}' does not match the desired state '{2}'.
    TestingPullServerWebSiteApplicationPool              = Testing the Pull Server web site application pool.
    PullServerWebSiteApplicationPoolMismatch             = Pull Server web site '{0}' currently bound application pool '{1}' does not match the desired state '{2}'.
    TestingPullServerWebSiteBinding                      = Testing the Pull Server web site binding.
    TestingPullServerWebSiteFirewallRuleSettings         = Testing the Pull Server web site firewall rule settings.
    FirewallRuleExistsAndShouldNot                       = Firewall rule exists for port '{0}' and should not.
    FirewallRuleDoesNotExistButShould                    = Firewall rule does not exist for port '{0}' but should.
    PullServerWebSiteNotConfiguredForHttp                = Pull Server web site '{0}' is not configured for HTTP and does not match the desired state.
    PullServerWebSiteNotConfiguredForHttps               = Pull Server web site '{0}' is not configured for HTTPS and does not match the desired state.
    PullServerWebSiteThumbprintMismatch                  = Pull Server web site '{0}' certificate thumbprint '{1}' does not match the desired state '{2}'.
    TestingPullServerWebSitePhysicalPath                 = Testing the Pull Server web site physical path.
    PullServerWebSitePhysicalPathMismatch                = Pull Server web site '{0}' physical path '{1}' does not match the desired state.
    TestingPullServerWebSiteState                        = Testing the Pull Server web site state.
    PullServerWebSiteStateMismatch                       = Pull Server web site '{0}' state '{1}' does not match the desired state '{2}'.
    TestingPullServerWebSiteDatabasePath                 = Testing the Pull Server web site database path.
    CurrentDatabaseProviderInvalid                       = The current database provider does not have a valid value. It should be either 'ESENT' or 'System.Data.OleDb'.
    TestingPullServerWebSiteModulePath                   = Testing the Pull Server web site module path.
    TestingPullServerWebSiteConfigurationPath            = Testing the Pull Server web site configuration path.
    TestingPullServerWebSiteRegistrationKeyPath          = Testing the Pull Server web site registration key path.
    TestingPullServerWebSiteAcceptSelfSignedCertificates = Testing the Pull Server web site AcceptSelfSignedCertificates.
    AcceptSelfSignedCertificatesEnabled                  = AcceptSelfSignedCertificates is enabled. Checking self-signed IIS module is configured for Pull Server web site at '{0}'.
    PullServerWebSiteModuleNotEnabledButShouldBe         = Pull Server web site '{0}' self-signed IIS module not enabled but should be.
    PullServerWebSiteModuleEnabledAndShouldBe            = Pull Server web site '{0}' self-signed IIS module enabled and should be.
    IisSelfSignedModuleNotInstalledButShouldBe           = Self-signed module not installed into IIS but should be.
    AcceptSelfSignedCertificatesDisabled                 = AcceptSelfSignedCertificates is disabled. Checking self-signed IIS module is not configured for Pull Server web site at '{0}'.
    PullServerWebSiteModuleEnabledButShouldNotBe         = Pull Server web site '{0}' self-signed IIS module enabled and should not be.
    PullServerWebSiteModuleNotEnabledAndShouldNotBe      = Pull Server web site '{0}' self-signed IIS module not enabled but should not be.
    IisSelfSignedModuleNotInstalledAndShouldNotBe        = Self-signed module not installed into IIS and should not be.
    TestingPullServerWebSiteUseSecurityBestPractices     = Testing the Pull Server web site UseSecurityBestPractices.
    PullServerWebSiteSecuritySettingsMismatch            = Pull Server web site '{0}' UseSecurityBestPractices does not match the desired state.
    WebConfigFileNotFound                                = 'Web.Config' file not found at '{0}'.
    WebConfigAppSettingStateMismatch                     = The state of 'Web.Config' AppSetting '{0}' does not match the desired state '{1}'.
    TestingFileDifference                                = Testing for file difference between '{0}' and '{1}'.
    DestinationFilePathIsAContainer                      = '{0}' is a container (directory) not a leaf (file).
    DestinationFileAlreadyExists                         = Destination file '{0}' already exists.
    DestinationFileDoesNotExist                          = Destination file '{0}' does not exist.
    InstallIisSelfSignedModule32BitProcess               = Installing IIS self-signed module, providing '{0}' to run in a 32 bit process.
    IisSelfSignedModuleAlreadyInstalled                  = IIS self-signed module '{0}' is already installed.
    InstallIisSelfSignedModule                           = Installing IIS self-signed module '{0}'.
    IisSelfSignedModuleAlreadyInstalledLocation          = IIS self-signed module '{0}' already installed at '{1}' with the correct version.
    ActivatingIisSelfSignedModule                        = Globally activating IIS self-signed module '{0}'.
    TestingIisSelfSignedModuleEnabled                    = Testing IIS self-signed module enabled on web site '{0}'.
    TestingIisSelfSignedModuleWebConfigEnabled           = Testing IIS self-signed module enabled in '{0}'.
    IisWebSiteNotFound                                   = Web site with endpoint '{0}' not found.
    EnableIisSelfSignedModule                            = Enable IIS self-signed module on web site '{0}' with Enable32BitAppOnWin64 '{1}'.
    DisableIisSelfSignedModule                           = Disable IIS self-signed module on web site '{0}'.
'@
